#ifndef _POLY1DEBGREE_H_
#define _POLY1DEBGREE_H_
// ==========================================================================
// $Source: /users/huron/gautier/projets/CVS/Givaro/src/library/poly1/givdegree.h,v $
// Copyright(c)'94-97 by Givaro Team
// see the copyright file.
// Authors: T. Gautier
// $Id: givdegree.h,v 1.0.0.1 1999/04/15 10:13:57 gautier Exp $
// Description: opaque class for Degree of polynomial. Degree of polynomial
// 0 is Degree::deginfty with value DEGPOLYZERO.
// ==========================================================================

#include <iostream.h>

// -- Degree type for polynomials
// 
class Degree { 
public:
    typedef long value_type;

  enum { DEGPOLYZERO =-1};
    Degree(long a = DEGPOLYZERO): _deg(a) { }
    
//   // -- cast --> long
//     operator long() { return _deg; }            

  // -- Degree of zero polynomial
  static const long deginfty;

  // -- cvrt
  long value() const { return _deg; }

  // -- Basic arithmetic:
  Degree operator+( const Degree& d) const { return Degree(_deg+d._deg); }
  Degree operator-( const Degree& d) const { return Degree(_deg-d._deg); }
  Degree operator*( const Degree& d) const { return Degree(_deg*d._deg); }
  Degree operator/( const Degree& d) const { return Degree(_deg/d._deg); }
  long operator++() { return ++_deg; }
  long operator--() { return --_deg; }
  long operator++(int) { return _deg++; }
  long operator--(int) { return _deg--; }
  
  // -- Comparizon:
  int operator==( const Degree& d) const { return _deg == d._deg; }
  int operator!=( const Degree& d) const { return _deg != d._deg; }
  int operator<=( const Degree& d) const { return _deg <= d._deg; }
  int operator< ( const Degree& d) const { return _deg <  d._deg; }
  int operator>=( const Degree& d) const { return _deg >= d._deg; }
  int operator> ( const Degree& d) const { return _deg >  d._deg; }
  
  // -- methods
    friend ostream& operator<< (ostream& o, const Degree& d) { return o << d._deg; }
    friend istream& operator>> (istream& i, Degree& d) { return i >> d._deg; }
    

public:
  long _deg;
};
inline long value(const Degree& d) { return d._deg; }
// inline   int operator==( int i, const Degree& d) { return i == d._deg; }
// inline   int operator!=( int i, const Degree& d) { return i != d._deg; }
// inline   int operator<=( int i, const Degree& d) { return i <= d._deg; }
// inline   int operator< ( int i, const Degree& d) { return i <  d._deg; }
// inline   int operator>=( int i, const Degree& d) { return i >= d._deg; }
// inline   int operator> ( int i, const Degree& d) { return i >  d._deg; }

#endif
