// ==========================================================================
// $Source: /users/huron/gautier/projets/CVS/Givaro/src/library/poly1/givpoly1io.inl,v $
// Copyright(c)'94-97 by Givaro Team
// see the copyright file.
// Authors: T. Gautier
// $Id: givpoly1io.inl,v 1.0.0.1 1999/04/15 10:13:58 gautier Exp $
// ==========================================================================
// Description:


  // --
template<class Domain>
istream& Poly1Dom<Domain,Dense>::read ( istream& i )
{
  char ch;
  sin >> ws >> ch;
  if (ch != '(')
    GivError::throw_error(
      GivBadFormat("Poly1Dom<Domain,Dense>::read: syntax error no '('"));

  _domain.read(i);

  sin >> ws >> ch;
  if (ch != ',')
    GivError::throw_error(
      GivBadFormat("Poly1Dom<Domain,Dense>::read: syntax error no ','"));

  i >> _x;

  sin >> ws >> ch;
  if (ch != ')')
    GivError::throw_error(
      GivBadFormat("Poly1Dom<Domain,Dense>::read: syntax error no ')'"));
}

template<class Domain>
ostream& Poly1Dom<Domain,Dense>::write( ostream& o ) const
{
  return _domain.write(o << '(') << ',' << _x << ')';
}



template<class Domain>
ostream& Poly1Dom<Domain,Dense>::write( ostream& o, const Rep& R) const
{
    if (R.size()) {
        Rep P; assign(P, R);
        setdegree(P);
        if (P.size()) {
            if (! _domain.iszero(P[0])) 
                if (_domain.isone(P[0]))
                    _domain.write(o,P[0]);
                else
                    _domain.write(o << "(",P[0]) << ")";
            if (P.size() > 1) {
                if (! _domain.iszero(P[0])) o << " + ";
                if (! _domain.iszero(P[1])) {
                    if (! _domain.isone(P[1])) {
                        _domain.write(o << "(",P[1]) << ")*";
                    }
                    o << _x;
                }
                for(long l=2;l<P.size();++l) {
                    if (! _domain.iszero(P[l-1])) o << " + ";
                    if (! _domain.iszero(P[l])) {
                        if (! _domain.isone(P[l])) {
                            _domain.write(o << "(",P[l]) << ")*";
                        }
                        o << _x << "^" << l; 
                    }
                }
            }
            return o;
        }
    } 
    return o << "0";
}

template<class Domain>
istream& Poly1Dom<Domain,Dense>::read ( istream& i, Rep& P) const
{
    long deg;
    i >> deg;
    init(P,Degree(deg));
    for(;deg>=0;--deg)
        i >> P[deg];
    return i;
}
